function filterEq(eq, row){
    if(eq.type === "and"){
        for (var i = 0; i < eq.eqs.length; i++) {
            if(!filterEq(eq.eqs[i], row)){
                return false
            }
        }
        return true
    } else if(eq.type === "or"){
        for (var i = 0; i < eq.eqs.length; i++) {
            if(filterEq(eq.eqs[i], row)){
                return true
            }
        }
        return false
    } else {
        if(eq.val && eq.valType === "date" && typeof(eq.val) === "string"){
            eq.val = new Date(eq.val)
        }
        if(eq.valType === "date"){
            return compareDate(row[eq.key], eq.op, eq.val)
        } else {
            return opFilter(row[eq.key], eq.op, eq.val)
        }
    }
}

function compareDate(what, op, val){
    switch (op) {
        case "==": {
            if(val === "" || !val){
                return !what || (what == "")
            }
            if(!what){
                return false
            }
            var isSameDay = (what.getDate() == val.getDate()
            && what.getMonth() == val.getMonth()
            && what.getFullYear() == val.getFullYear())
            return isSameDay
            break
        }
        case "!=": {
            if(val === "" || !val){
                console.log(what)
                return what && (what != "")
            }
            if(!what){
                return true
            }
            var isSameDay = (what.getDate() == val.getDate()
            && what.getMonth() == val.getMonth()
            && what.getFullYear() == val.getFullYear())
            return !isSameDay
            break
        }
        case ">":{
            return what > val
            break
        }
        case "<":{
            return what < val
            break
        }
    }
}

function opFilter(what, op, val){
    switch (op) {
        case "==": {
            if(val === "" || !val){
                return !what || (what == "")
            }
            return what == val
            break;
        }
        case "!=": {
            if(val === "" || !val){
                return what && (what != "")
            }
            return what != val
            break;
        }
        case ">":{
            return what > val
            break;
        }
        case "<":{
            return what < val
            break;
        }
        case "c":{
            return String(what).toLowerCase().indexOf(val.toLowerCase()) > -1
            break;
        }
    }
}

function parseFilter(filter){
    if(filter.charAt(0) === '>'){
        return {
            op: ">",
            val: filter.substr(1)
        }
    }
    if(filter.charAt(0) === '<'){
        return {
            op: "<",
            val: filter.substr(1)
        }
    }
    if(filter.charAt(0) === '=' && filter.charAt(1) === '='){
        return {
            op: "==",
            val: filter.substr(2)
        }
    }
    if(filter.charAt(0) === '!' && filter.charAt(1) === '='){
        return {
            op: "!=",
            val: filter.substr(2)
        }
    }
    return filter
}

function smartFilter(col, row){
    if(typeof(col.filter) === "string"){
        if(col.render){
            return String(col.render(row)).toLowerCase().indexOf(col.filter.toLowerCase()) > -1
        } else {
            return String(row[col.key]).toLowerCase().indexOf(col.filter.toLowerCase()) > -1
        }
    } else {
        return opFilter(row[col.key], col.filter.op, col.filter.val)
    }
}

exports.filterEq = filterEq
exports.smartFilter = smartFilter
exports.parseFilter = parseFilter
