const merge = require('webpack-merge');
const path = require('path');

var config = {
    output: {
        path: __dirname+'/dist/'
    },
    module: {
        loaders: [
            {
                test: /\.js$/,
                loader: 'babel-loader',
                exclude: /node_modules/
            }, {
                test: /\.vue$/,
                loader: 'vue-loader'
            }
        ]
    },
    resolve: {
        alias: {
            vue: 'vue/dist/vue.js'
        }
    }
}


module.exports = [
    // Config 1: For browser environment
    merge(config, {
        entry: path.resolve(__dirname + '/src/plugin.js'),
        output: {
            filename: 'vue-ltable.min.js',
            libraryTarget: 'window',
            library: 'VueLtable'
        }
    }),

    // Config 2: For Node-based development environments
    merge(config, {
        entry: path.resolve(__dirname + '/src/Table.vue'),
        output: {
            filename: 'vue-ltable.js',
            libraryTarget: 'umd',
            library: 'vue-ltable',
            umdNamedDefine: true
        }
    })
];
